package ru.dbotthepony.mc.otm.mixin;

import net.minecraft.client.gui.GuiGraphics;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.Overwrite;

import static ru.dbotthepony.mc.otm.client.render.RenderHelperKt.popScissorRect;
import static ru.dbotthepony.mc.otm.client.render.RenderHelperKt.pushScissorRect;

// because scissor stack fucking sucks.
// mostly because it is not a stack at all.
@Mixin(GuiGraphics.class)
public abstract class GuiGraphicsMixin {
	@Overwrite
	public void enableScissor(int x0, int y0, int x1, int y1) {
		pushScissorRect(x0, y0, x1 - x0, y1 - y0);
	}

	@Overwrite
	public void disableScissor() {
		popScissorRect();
	}
}
